// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Checkers.java

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.reflect.Method;
import javax.imageio.ImageIO;
import javax.sound.midi.*;
import javax.swing.*;
import javax.swing.filechooser.FileFilter;

public class Checkers extends JApplet
    implements ActionListener, WindowListener
{

    public static void main(String args[])
    {
        new Checkers(args);
    }

    public Checkers()
    {
    }

    public Checkers(String args[])
    {
        JPopupMenu.setDefaultLightWeightPopupEnabled(false);
        JFrame.setDefaultLookAndFeelDecorated(true);
        JFrame frame = new JFrame("Moparisthebest's Checkers");
        frame.setResizable(false);
        frame.setDefaultCloseOperation(0);
        contentPane = frame.getContentPane();
        initUI(frame);
        frame.addWindowListener(this);
        frame.pack();
        frame.setVisible(true);
        musicPlayer("Play");
    }

    public void init()
    {
        contentPane = getContentPane();
        initUI(null);
    }

    public void initUI(JFrame frame)
    {
        int checkerBoardSize = 400;
        checkers = new CheckerBoard();
        checkers.setSize(checkerBoardSize, checkerBoardSize);
        String titles[] = {
            "File", "Music Player", "Help"
        };
        String content[][] = {
            {
                "New Game", "Save Game", "Load Game", "-", "Set ScreenShot Directory", "ScreenShot", "-", "Quit"
            }, {
                "Next Song", "Previous Song", "-", "Play", "Stop", "-", "Set Music Directory", "Info"
            }, {
                "Website", "Forums"
            }
        };
        if(frame == null)
            setJMenuBar(makeMenuBar(titles, content, this));
        else
            frame.setJMenuBar(makeMenuBar(titles, content, this));
        contentPane.setLayout(new BorderLayout());
        contentPane.add(checkers, "Center");
        contentPane.setPreferredSize(checkers.getSize());
        checkers.init();
    }

    private String chooseFile(String dialogTitle, String defaultStr, int fileSelectMode)
    {
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(fileSelectMode);
        chooser.setDialogTitle(dialogTitle);
        int returnVal = chooser.showOpenDialog(contentPane);
        if(returnVal == 0)
            return chooser.getSelectedFile().getAbsolutePath();
        else
            return defaultStr;
    }

    public void saveGame()
    {
        String saveDir = chooseFile("Select a file to save the game to:", "./game1.chk", 2);
        if(!saveDir.endsWith(".chk"))
            saveDir = (new StringBuilder()).append(saveDir).append(".chk").toString();
        try
        {
            ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(saveDir));
            oos.writeObject(checkers);
            oos.close();
            System.out.println("saved game.");
        }
        catch(Exception e)
        {
            System.out.println("Cannot save game.");
            e.printStackTrace();
        }
    }

    public void loadGame()
    {
        String absPath = "";
        JFileChooser chooser = new JFileChooser();
        chooser.addChoosableFileFilter(new FileFilter() {

            public boolean accept(File f)
            {
                String name = f.getName();
                return f.isDirectory() || name.endsWith(".chk");
            }

            public String getDescription()
            {
                return "Moparisthebest's Checkers saved game (.chk)";
            }

            final Checkers this$0;

            
            {
                this$0 = Checkers.this;
                super();
            }
        }
);
        int returnVal = chooser.showOpenDialog(contentPane);
        if(returnVal == 0)
        {
            absPath = chooser.getSelectedFile().getAbsolutePath();
            System.out.println((new StringBuilder()).append("You chose to open this game: ").append(absPath).toString());
        } else
        {
            System.out.println("Cannot load game.");
        }
        try
        {
            ObjectInputStream ois = new ObjectInputStream(new FileInputStream(absPath));
            CheckerBoard cb = (CheckerBoard)ois.readObject();
            ois.close();
            contentPane.remove(checkers);
            checkers = cb;
            contentPane.add(checkers, "Center");
            checkers.repaint();
            System.out.println("loaded game.");
        }
        catch(Exception e)
        {
            System.out.println("Cannot load game.");
            e.printStackTrace();
        }
    }

    public void windowClosing(WindowEvent e)
    {
        onClose();
    }

    public void windowDeactivated(WindowEvent windowevent)
    {
    }

    public void windowActivated(WindowEvent windowevent)
    {
    }

    public void windowOpened(WindowEvent windowevent)
    {
    }

    public void windowClosed(WindowEvent windowevent)
    {
    }

    public void windowIconified(WindowEvent windowevent)
    {
    }

    public void windowDeiconified(WindowEvent windowevent)
    {
    }

    public void onClose()
    {
        int s = JOptionPane.showConfirmDialog(this, "Do you want to save your game?");
        if(s == 0)
            saveGame();
        if(s != 2)
            System.exit(0);
    }

    public void actionPerformed(ActionEvent evt)
    {
        String cmd = evt.getActionCommand();
        if(cmd.equals("New Game"))
            checkers.reset();
        if(cmd.equals("Save Game"))
            saveGame();
        if(cmd.equals("Load Game"))
            loadGame();
        if(cmd.equals("Set ScreenShot Directory"))
            screenyDir = (new StringBuilder()).append(chooseFile("Select a directory to save screenshots to:", screenyDir, 1)).append("/").toString();
        if(cmd.equals("Set Music Directory"))
            musicDir = (new StringBuilder()).append(chooseFile("Select a directory to play music from:", musicDir, 1)).append("/").toString();
        else
        if(cmd.equalsIgnoreCase("ScreenShot"))
            takeScreenShot(checkers);
        else
        if(cmd.equalsIgnoreCase("Next Song"))
            musicPlayer("Next");
        else
        if(cmd.equalsIgnoreCase("Previous Song"))
            musicPlayer("Previous");
        else
        if(cmd.equalsIgnoreCase("Play"))
            musicPlayer("Play");
        else
        if(cmd.equalsIgnoreCase("Stop"))
            musicPlayer("Stop");
        else
        if(cmd.equals("Website"))
            launchURL("http://www.moparisthebest.com");
        else
        if(cmd.equals("Forums"))
            launchURL("http://www.moparisthebest.com/smf/");
        else
        if(cmd.equals("Quit"))
            onClose();
        else
        if(cmd.equalsIgnoreCase("Info"))
            JOptionPane.showMessageDialog(this, (new StringBuilder()).append("This Music player can play both midi (.mid) or mp3 formats.\nJust put any songs in the \"").append(musicDir).append("\" folder to play them.").toString(), "Music Player Info", -1);
    }

    private static void musicPlayer(String command)
    {
        chkDir(musicDir);
        if(player != null && player.isRunning())
            player.close();
        if(sequencer != null && sequencer.isRunning())
        {
            sequencer.stop();
            sequencer.close();
        }
        if(command.equals("Next"))
            midiCount++;
        else
        if(command.equals("Previous"))
            midiCount--;
        if(!command.equals("Stop"))
        {
            File index = new File(musicDir);
            String fileList[] = index.list();
            if(fileList.length > 0)
            {
                if(midiCount > fileList.length - 1)
                    midiCount = 0;
                if(midiCount < 0)
                    midiCount = fileList.length - 1;
                if(fileList[midiCount].endsWith(".mp3"))
                {
                    System.out.println((new StringBuilder()).append("Playing ").append(fileList[midiCount]).toString());
                    player = new MP3Player((new StringBuilder()).append(musicDir).append(fileList[midiCount]).toString(), true);
                } else
                if(fileList[midiCount].endsWith(".mid"))
                {
                    System.out.println((new StringBuilder()).append("Playing ").append(fileList[midiCount]).toString());
                    try
                    {
                        File midiFile = new File((new StringBuilder()).append(musicDir).append(fileList[midiCount]).toString());
                        sequencer = MidiSystem.getSequencer();
                        sequencer.setSequence(MidiSystem.getSequence(midiFile));
                        sequencer.setLoopCount(-1);
                        sequencer.open();
                        sequencer.start();
                    }
                    catch(MidiUnavailableException mue)
                    {
                        System.out.println("Midi device unavailable!");
                    }
                    catch(InvalidMidiDataException imde)
                    {
                        System.out.println("Invalid Midi data!");
                    }
                    catch(IOException ioe)
                    {
                        System.out.println("I/O Error!");
                    }
                }
            } else
            {
                System.out.println("no midi or mp3 files in folder");
            }
        }
    }

    private static void chkDir(String fileName)
    {
        try
        {
            File f = new File(fileName);
            if(!f.exists())
                f.mkdir();
        }
        catch(Exception e)
        {
            System.out.println((new StringBuilder()).append("Error making file: ").append(e).toString());
        }
    }

    private static void takeScreenShot(Component component)
    {
        try
        {
            Point c = component.getLocationOnScreen();
            int x = c.x;
            int y = c.y;
            int width = component.getWidth();
            int height = component.getHeight();
            Rectangle screenRect = new Rectangle(x, y, width, height);
            Robot robot = new Robot();
            java.awt.image.BufferedImage image = robot.createScreenCapture(screenRect);
            chkDir(screenyDir);
            String screenyName = (new StringBuilder()).append("Screenshot").append(countScreenys()).append(".png").toString();
            File file = new File((new StringBuilder()).append(screenyDir).append(screenyName).toString());
            ImageIO.write(image, "png", file);
            System.out.println((new StringBuilder()).append("Screenshot saved as ").append(screenyName).toString());
        }
        catch(Exception e)
        {
            System.out.println((new StringBuilder()).append("Error saving screenshot: ").append(e).toString());
        }
    }

    private static int countScreenys()
    {
        int i = 0;
        File file = new File(screenyDir);
        String list[] = file.list();
        String arr$[] = list;
        int len$ = arr$.length;
        for(int i$ = 0; i$ < len$; i$++)
        {
            String s = arr$[i$];
            if(s.endsWith(".png"))
                i++;
        }

        return i;
    }

    private static void launchURL(String url)
    {
        String osName = System.getProperty("os.name");
        try
        {
            if(osName.startsWith("Mac OS"))
            {
                Class fileMgr = Class.forName("com.apple.eio.FileManager");
                Method openURL = fileMgr.getDeclaredMethod("openURL", new Class[] {
                    java/lang/String
                });
                openURL.invoke(null, new Object[] {
                    url
                });
            } else
            if(osName.startsWith("Windows"))
            {
                Runtime.getRuntime().exec((new StringBuilder()).append("rundll32 url.dll,FileProtocolHandler ").append(url).toString());
            } else
            {
                String browsers[] = {
                    "firefox", "opera", "konqueror", "epiphany", "mozilla", "netscape"
                };
                String browser = null;
                for(int count = 0; count < browsers.length && browser == null; count++)
                    if(Runtime.getRuntime().exec(new String[] {
    "which", browsers[count]
}).waitFor() == 0)
                        browser = browsers[count];

                if(browser == null)
                    throw new Exception("Could not find web browser");
                Runtime.getRuntime().exec(new String[] {
                    browser, url
                });
            }
        }
        catch(Exception e)
        {
            System.out.println("Error opening URL");
            e.printStackTrace();
        }
    }

    private static JMenuBar makeMenuBar(String menuTitles[], String menuContent[][], ActionListener as)
        throws IllegalArgumentException
    {
        if(menuTitles.length != menuContent.length)
            throw new IllegalArgumentException();
        JMenuBar menuBar = new JMenuBar();
        for(int x = 0; x < menuTitles.length; x++)
        {
            JMenu fileMenu = new JMenu(menuTitles[x]);
            String arr$[] = menuContent[x];
            int len$ = arr$.length;
            for(int i$ = 0; i$ < len$; i$++)
            {
                String name = arr$[i$];
                JMenuItem menuItem = new JMenuItem(name);
                if(name.equalsIgnoreCase("-"))
                {
                    fileMenu.addSeparator();
                } else
                {
                    menuItem.addActionListener(as);
                    fileMenu.add(menuItem);
                }
            }

            menuBar.add(fileMenu);
        }

        return menuBar;
    }

    private CheckerBoard checkers;
    private Container contentPane;
    private static String screenyDir = "./Screenshots/";
    private static String musicDir = "./Music/";
    private static MP3Player player;
    private static int midiCount = 0;
    private static Sequencer sequencer;

}
